package net.krakatoaapi.event;

import earth.krakatao.protocol.KraSocketClientProtocolMessage;
import java.util.function.Consumer;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.jetbrains.annotations.NotNull;

@RequiredArgsConstructor
@Getter
public class SocketMessageEvent extends Event {

  private static final HandlerList handlers = new HandlerList();

  @Setter
  private boolean cancelled;

  private final int status;
  private final int cmdID;
  private final int dest;
  private final String uuid;
  private final int commandNumber;
  private final String args;
  private final Consumer<KraSocketClientProtocolMessage> messageConsumer;

  public static HandlerList getHandlerList() {
    return handlers;
  }

  public @NotNull
  HandlerList getHandlers() {
    return handlers;
  }
}
