package net.krakatoaapi.listener;

import net.krakatoaapi.KrakatoaAPI;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;
import org.redisson.api.RMap;

public class PlayerJoinListener implements Listener {

    @EventHandler
    public void onJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();

        event.setJoinMessage(null);

        String uuid = KrakatoaAPI.getInstance().getFormatter()
                .formatUuid(player.getUniqueId().toString());

        RMap<String, String> map = KrakatoaAPI.getInstance().getRedisManager()
                .getRedissonClient()
                .getMap("player:" + uuid);

        if (!map.isEmpty()) {
            KrakatoaAPI.getInstance().getLogger().info("redis player: " + map.keySet());

            map.put("currentServer", String.valueOf(KrakatoaAPI.getInstance().getKraSocketClient().getSocketClient().getDest()));
        }


        // TODO: server != lobby -> send player to last location
/*
    RMap<String, String> map = ProxySystem.getInstance().getRedisManager()
        .getRedissonClient()
        .getMap("player:" + uuid); */
    }
}
