package net.krakatoaapi.listener;

import de.dytanic.cloudnet.driver.CloudNetDriver;
import net.krakatoaapi.KrakatoaAPI;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerQuitEvent;
import org.redisson.api.RMap;

import java.util.Objects;

public class PlayerQuitListener implements Listener {

    @EventHandler
    public void onQuit(PlayerQuitEvent event) {
        Player player = event.getPlayer();

        event.setQuitMessage(null);

        String uuid = KrakatoaAPI.getInstance().getFormatter().formatUuid(Objects.requireNonNull(player.getPlayer()).getUniqueId());

        /*
         * Saving the player location when disconnecting for the next server join
         */
        if (!CloudNetDriver.getInstance().getComponentName().startsWith("Lobby")) {
            RMap<Object, Object> map = KrakatoaAPI.getInstance().getRedisManager().getPlayer(uuid);


            KrakatoaAPI.getInstance().getLogger().info("quit " + map.keySet());

            if (!map.isEmpty()) {
                map.put("lastLocation", round(player.getLocation().getX()) + " " + round(player.getLocation().getY()) + " " + round(player.getLocation().getZ()));
            }

            RMap<String, String> map2 = KrakatoaAPI.getInstance().getRedisManager()
                    .getRedissonClient()
                    .getMap("player:" + uuid);

            KrakatoaAPI.getInstance().getLogger().info("quit2 " + map2.keySet());
        }
    }

    public double round(double location) {
        return Math.round(location * 100.0) / 100.0;
    }

}
