package net.krakatoaapi.listener;

import earth.krakatao.events.KraSocketClientEventInterface;
import earth.krakatao.protocol.KraSocketClientProtocolMessage;
import net.krakatoaapi.KrakatoaAPI;
import net.krakatoaapi.event.SocketMessageEvent;
import org.bukkit.Bukkit;
import org.java_websocket.handshake.ServerHandshake;

public class SocketClientMessageListener implements KraSocketClientEventInterface {

  @Override
  public void onOpen(ServerHandshake serverHandshake) {

  }

  @Override
  public void onMessage(KraSocketClientProtocolMessage kraSocketClientProtocolMessage) {
    Bukkit.getScheduler().runTask(KrakatoaAPI.getInstance(), () -> {
      Bukkit.getServer().getPluginManager().callEvent(
          new SocketMessageEvent(kraSocketClientProtocolMessage.getStatus(),
              kraSocketClientProtocolMessage.getCmdID(),
              kraSocketClientProtocolMessage.getDest(),
              kraSocketClientProtocolMessage.getUuid().toString(),
              kraSocketClientProtocolMessage.getCmdNumber(),
              kraSocketClientProtocolMessage.getArgs(),
              kraSocketClientProtocolMessage.getMessageConsumer()));
    });
  }

  @Override
  public void onClose(int code, String reason, boolean remote) {
    if (code != 1) {
      Bukkit.getScheduler().runTaskLater(KrakatoaAPI.getInstance(), () -> {
        KrakatoaAPI.getInstance().getKraSocketClient().getSocketClient().Reconnect();
      }, 20);
    }
  }
}
